package com.ym.mec.auth.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import com.ym.mec.auth.api.entity.SysMenu;
import com.ym.mec.auth.dal.dao.SysMenuDao;
import com.ym.mec.auth.service.SysMenuService;
import com.ym.mec.common.dal.BaseDAO;
import com.ym.mec.common.service.impl.BaseServiceImpl;

import java.util.List;

@Service
public class SysMenuServiceImpl extends BaseServiceImpl<Integer, SysMenu>  implements SysMenuService {
	
	@Autowired
	private SysMenuDao sysMenuDao;

	@Override
	public BaseDAO<Integer, SysMenu> getDAO() {
		return sysMenuDao;
	}

	@Override
	public List<SysMenu> getMenusByRoleId(Integer roleId) {
		return sysMenuDao.getMenusByRoleId(roleId);
	}

	@Override
	public List<SysMenu> findByUser(Integer id) {
		return sysMenuDao.findByUser(id);
	}

	@Override
	public SysMenu findMenuByPermission(String permission){
		return sysMenuDao.findMenuByPermission(permission);
	}
}