package com.ym.mec.web.controller;

import com.ym.mec.common.controller.BaseController;
import com.ym.mec.common.page.QueryInfo;
import com.ym.mec.web.dal.entity.ClassGroup;
import com.ym.mec.web.service.ClassGroupService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;

@RequestMapping("classGroup")
@Api(tags = "班级服务")
@RestController
public class ClassGroupController extends BaseController {

    @Autowired
    private ClassGroupService classGroupService;

    @ApiOperation(value = "新增班级")
    @PostMapping("/add")
    public Object add(@RequestBody ClassGroup classGroup) {
        Date date = new Date();
        classGroup.setCreateTime(date);
        classGroup.setUpdateTime(date);
        classGroupService.insert(classGroup);
        return succeed();
    }

    @ApiOperation(value = "删除班级")
    @DeleteMapping("/del/{id}")
    public Object del(@ApiParam(value = "班级编号", required = true) @PathVariable("id") Integer id) {
        classGroupService.delete(id);
        return succeed();
    }

    @ApiOperation(value = "修改班级")
    @PutMapping("/update")
    public Object update(@RequestBody ClassGroup classGroup) {
        classGroup.setUpdateTime(new Date());
        classGroupService.update(classGroup);
        return succeed();
    }

    @ApiOperation(value = "分页查询班级列表")
    @PostMapping("/queryPage")
    public Object queryPage(@RequestBody QueryInfo queryInfo) {
        return succeed(classGroupService.queryPage(queryInfo));
    }
}
