package com.ym.mec.web.controller;

import com.ym.mec.common.controller.BaseController;
import com.ym.mec.common.page.QueryInfo;
import com.ym.mec.web.dal.entity.MusicGroupPaymentEntities;
import com.ym.mec.web.service.MusicGroupPaymentEntitiesService;
import io.swagger.annotations.Api;
import io.swagger.annotations.ApiOperation;
import io.swagger.annotations.ApiParam;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.web.bind.annotation.*;

import java.util.Date;
import java.util.List;

@RequestMapping("musicGroupPaymentEntities")
@Api(tags = "乐团付费主体服务")
@RestController
public class MusicGroupPaymentEntitiesController extends BaseController {

    @Autowired
    private MusicGroupPaymentEntitiesService musicGroupPaymentEntitiesService;

    @ApiOperation(value = "新增乐团付费主体")
    @PostMapping("/add")
    public Object add(@RequestBody MusicGroupPaymentEntities musicGroupPaymentEntities){
        Date date = new Date();
        musicGroupPaymentEntities.setCreateTime(date);
        musicGroupPaymentEntities.setUpdateTime(date);
        musicGroupPaymentEntitiesService.insert(musicGroupPaymentEntities);
        return succeed();
    }

    @ApiOperation(value = "批量新增乐团付费主体")
    @PostMapping("/batchAdd")
    public Object batchAdd(@RequestBody List<MusicGroupPaymentEntities> musicGroupPaymentEntities){
        musicGroupPaymentEntitiesService.batchInsert(musicGroupPaymentEntities);
        return succeed();
    }

    @ApiOperation(value = "删除乐团付费主体")
    @DeleteMapping("/del/{id}")
    public Object del(@ApiParam(value = "乐团付费主体编号", required = true) @PathVariable("id") Integer id){
        musicGroupPaymentEntitiesService.delete(id);
        return succeed();
    }

    @ApiOperation(value = "修改乐团付费主体")
    @PutMapping("/update")
    public Object update(@RequestBody MusicGroupPaymentEntities musicGroupPaymentEntities){
        musicGroupPaymentEntities.setUpdateTime(new Date());
        musicGroupPaymentEntitiesService.update(musicGroupPaymentEntities);
        return succeed();
    }

    @ApiOperation(value = "分页查询乐团付费主体")
    @PostMapping("/queryPage")
    public Object queryPage(@RequestBody QueryInfo queryInfo){
        return succeed(musicGroupPaymentEntitiesService.queryPage(queryInfo));
    }
}
