package com.ym.mec.web.dal.dao;

import com.ym.mec.common.dal.BaseDAO;
import com.ym.mec.web.dal.entity.Subject;
import com.ym.mec.web.dal.enums.YesOrNoEnum;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface SubjectDao extends BaseDAO<Integer, Subject> {

    /**
     * 通过乐团编号查询科目列表
     * @param musicGroupId
     * @return
     */
    List<Subject> findSubByMusicGroupId(Integer musicGroupId);

    /**
     * 通过乐团收费方式，获取默认的声部列表
     * @param chargeTypeId
     * @return
     */
    List<Subject> findSubByChargeType(Integer chargeTypeId);

    /**
     * 根据科目code查科目
     * @param code
     * @return Subject
     */
    Subject findByCode(@Param("code") String code);

    /**
     * 根据父级id查询子级列表
     * @param parentId
     * @return
     */
    List<Subject> findByParentId(@Param("parentId") String parentId, @Param("delFlag") YesOrNoEnum delFlag);
}