package com.ym.mec.web.service;

import com.ym.mec.common.page.PageInfo;
import com.ym.mec.common.service.BaseService;
import com.ym.mec.web.dal.entity.Subject;
import com.ym.mec.web.dal.page.SubjectQueryInfo;
import org.apache.ibatis.annotations.Param;

import java.util.List;

public interface SubjectService extends BaseService<Integer, Subject> {

    /**
     * 通过乐团编号查询科目列表
     * @param musicGroupId
     * @return
     */
    List<Subject> findSubByMusicGroupId(Integer musicGroupId);

    /**
     * 通过乐团收费方式，获取默认的声部列表
     * @param chargeTypeId
     * @return
     */
    List<Subject> findSubByChargeType(Integer chargeTypeId);

    /**
     * 根据科目code查科目
     * @param code
     * @return
     */
    Subject findByCode(@Param("code") String code);

    /**
     * 分页查询科目树状列表
     * @param queryInfo
     * @return
     */
    PageInfo<Subject> queryPageTree(SubjectQueryInfo queryInfo);
}