package com.ym.mec.web.service.impl;

import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.dao.DaoAuthenticationProvider;
import org.springframework.stereotype.Service;

import com.ym.mec.common.dal.BaseDAO;
import com.ym.mec.common.service.impl.BaseServiceImpl;
import com.ym.mec.web.dal.dao.MusicGroupPaymentEntitiesDao;
import com.ym.mec.web.dal.entity.MusicGroupPaymentEntities;
import com.ym.mec.web.service.MusicGroupPaymentEntitiesService;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.List;

@Service
public class MusicGroupPaymentEntitiesServiceImpl extends BaseServiceImpl<Integer, MusicGroupPaymentEntities>  implements MusicGroupPaymentEntitiesService {
	
	@Autowired
	private MusicGroupPaymentEntitiesDao musicGroupPaymentEntitiesDao;

	@Override
	public BaseDAO<Integer, MusicGroupPaymentEntities> getDAO() {
		return musicGroupPaymentEntitiesDao;
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void batchInsert(List<MusicGroupPaymentEntities> musicGroupPaymentEntities) {
		Date date = new Date();
		musicGroupPaymentEntities.forEach(e -> {
			e.setCreateTime(date);
			e.setUpdateTime(date);
			musicGroupPaymentEntitiesDao.insert(e);
		});
	}
}