package com.ym.mec.web.service.impl;

import com.ym.mec.web.dal.dao.MusicGroupSubjectGoodsGroupDao;
import com.ym.mec.web.dal.dao.MusicGroupSubjectPlanDao;
import com.ym.mec.web.dal.dao.SubjectDao;
import com.ym.mec.web.dal.entity.MusicGroupSubjectGoodsGroup;
import com.ym.mec.web.dal.entity.MusicGroupSubjectPlan;
import com.ym.mec.web.dal.entity.Subject;
import com.ym.mec.web.dal.utilEntity.SubSetViewUtilEntity;
import com.ym.mec.web.dal.utilEntity.SubSettingUtilEntity;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.security.authentication.dao.DaoAuthenticationProvider;
import org.springframework.stereotype.Service;

import com.ym.mec.common.dal.BaseDAO;
import com.ym.mec.common.service.impl.BaseServiceImpl;
import com.ym.mec.web.dal.dao.MusicGroupDao;
import com.ym.mec.web.dal.entity.MusicGroup;
import com.ym.mec.web.service.MusicGroupService;
import org.springframework.transaction.annotation.Transactional;

import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

@Service
public class MusicGroupServiceImpl extends BaseServiceImpl<String, MusicGroup>  implements MusicGroupService {
	
	@Autowired
	private MusicGroupDao musicGroupDao;
	@Autowired
	private SubjectDao subjectDao;
	@Autowired
	private MusicGroupSubjectPlanDao musicGroupSubjectPlanDao;
	@Autowired
	private MusicGroupSubjectGoodsGroupDao musicGroupSubjectGoodsGroupDao;

	@Override
	public BaseDAO<String, MusicGroup> getDAO() {
		return musicGroupDao;
	}

	@Override
	@Transactional(rollbackFor = Exception.class)
	public void subSetting(List<SubSettingUtilEntity> subSettingUtilEntitys) {
		Subject subject = null;
		MusicGroupSubjectPlan musicGroupSubjectPlan;
		Date date = new Date();
		for (SubSettingUtilEntity e:subSettingUtilEntitys) {
			subject = subjectDao.get(e.getSubId());
			//保存、修改乐团科目规划
			if(subject != null){
				musicGroupSubjectPlan = new MusicGroupSubjectPlan();
				musicGroupSubjectPlan.setMusicGroupId(e.getMusicGroupId());
				musicGroupSubjectPlan.setSubjectId(e.getSubId());
				musicGroupSubjectPlan.setExpectedStudentNum(e.getExpectedStudentNum());
				musicGroupSubjectPlan.setUpdateTime(date);
				if(e.getPlanId() != null){
					musicGroupSubjectPlan.setId(e.getPlanId());
					musicGroupSubjectPlanDao.update(musicGroupSubjectPlan);
				}else {
					musicGroupSubjectPlan.setCreateTime(date);
					musicGroupSubjectPlanDao.insert(musicGroupSubjectPlan);
				}
				//保存、修改乐团科目乐器范围，以及打包商品
				for (MusicGroupSubjectGoodsGroup m:e.getMusicGroupSubjectGoodsGroups()) {
					if(m.getId() == null){
						musicGroupSubjectGoodsGroupDao.insert(m);
					}else {
						m.setUpdateTime(date);
						musicGroupSubjectGoodsGroupDao.update(m);
					}
				}
			}
		}
	}

	@Override
	public List<SubSetViewUtilEntity> getSubSetting(Integer musicGroupId) {
		//获取已选择的声部
		List<SubSetViewUtilEntity> subSetViewUtilEntities = musicGroupSubjectPlanDao.findSubByGroupId(musicGroupId);
		//获取已选的商品组
		for (SubSetViewUtilEntity subSetViewUtilEntity:subSetViewUtilEntities) {
			subSetViewUtilEntity.setMusicGroupSubjectGoodsGroups(musicGroupSubjectGoodsGroupDao.findGoodsGroup(musicGroupId,subSetViewUtilEntity.getSubId()));
		}
		return subSetViewUtilEntities;
	}
}